/*
* TGPR: Transfer Learning Based Visual Tracking with Gaussian Process Regression
*
* Code to accompany the paper:
*   Transfer Learning Based Visual Tracking with Gaussian Process Regression
*   Jin Gao, Haibin Ling, Weiming Hu, Junliang Xing
*   ECCV2014, Part III, LNC 8691, pp. 188-203, 2014
*
* Copyright (C) 2014 Jin Gao
*
* This file is part of TGPR.
*
*
*The whole framework of this code is based on the framework of the publicly available code:
*
* Struck: Structured Output Tracking with Kernels
*
* Struck is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Struck is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Struck.  If not, see <http://www.gnu.org/licenses/>.
*
*/

#ifndef TIMING_H
#define TIMING_H

#include <iostream>
#include <vector>
#include <sys/timeb.h>
#include <ctime>
#include <climits>
#include "omp.h"

class Timing
{
public:
	class Timing() 	{	}
	struct timeb startTimer1, endTimer1;
	std::vector<double> TimeStore1;

	struct timeb startTimer2, endTimer2;
	std::vector<double> TimeStore2;

	struct timeb startTimer3, endTimer3;
	std::vector<double> TimeStore3;

	struct timeb startTimer4, endTimer4;
	std::vector<double> TimeStore4;

	struct timeb startTimer5, endTimer5;
	std::vector<double> TimeStore5;

	struct timeb startTimer6, endTimer6;
	std::vector<double> TimeStore6;

	struct timeb startTimer7, endTimer7;
	std::vector<double> TimeStore7;

	struct timeb startTimer8, endTimer8;
	std::vector<double> TimeStore8;

	inline void storetime(std::vector<double>& TimeStore, struct timeb startTime, struct timeb endTime) { TimeStore.push_back(gettime(startTime, endTime)); }

private:

	inline double gettime(struct timeb startTime, struct timeb endTime) const { return (double)((endTime.time - startTime.time) * 1000 + (endTime.millitm - startTime.millitm)) / 1000; }
};

#endif
